require 'curses'
require 'WikiMiner/db'
require 'tuplestream'
require 'WikiMiner/tasks'

Curses.init_screen

class Collector
  def initialize
    @classifications = {}
    TitleClassification.find(:all).each do |tc|
      @classifications[tc.name] = tc.classification
    end
  end

  def classify(entity)
    begin
      puts "#{entity} [(e)ntity/(n)on-entity/(s)kip/(o)pen/(q)quit] :"
      c = Curses.getch().chr
      puts "#{c}\n"
      
      system("cmd /c start http://en.wikipedia.org/wiki/#{entity.gsub(' ', '_')}") if c == 'o'
    end until %w(e n s q).include?(c)
    
    return c
  end
  
  def run
    puts "#{@classifications.size} existing classifications founds.\n"
    Titles.open :name => :shuffled do |stream|
      while (item = stream.read)
        (title,) = item
        
        unless @classifications.has_key?(title)
          classification = classify(title)
          
          type = nil
          case classification
          when 'e', 'n', 's'
            type = classification
          when 'q'
            return
          end
          
          if type
            @classifications[title] = type
            TitleClassification.create(:name => title, :classification => type)
          end
        end
      end
    end
  end
  
  def self.run
    c = Collector.new
    c.run
  end
end

Collector.run

#classify("Bush")
