require 'WikiMiner/db'
require 'tuple_stream'
require 'WikiMiner/tasks'
require 'EntityCollector/entities'

#class EntitiesWithCategory < TupleStream
#  define_field :name, :string
#  define_field :category, :string
#end

class ListEntitiesByCategory
  @@category_map = {
    :company => [
      'Companies headquartered in %', 
      'Companies established in %', 
      'Companies based in %',
      'Companies listed on %',
      '% companies of %',
      '% companies',
    ],
    :organization => [
      '% organizations',
      'Organizations based in %',
      'Organizations established in %',
    ],
    :person => [
      'Living people',
    ]
  }
  
  @@db = Config[:db]
  
  def initialize
  end
  
  def run
    #    EntitiesWithCategory.open :mode => :write do |output|
    Entities.open :name => :from_categories, :mode => :write do |output|
      @@category_map.each do |category, filters|
        puts "Finding '#{category}' entities...\n"
        entities = {}
      
        filters.each do |filter|
          puts "Running filter '#{filter}'..."
        
          count = 0
          @@db.execute('SELECT title FROM category_pages WHERE category LIKE :filter AND namespace = ""', 
            :filter => filter) do |row|
            count += 1
            entities[row['title']] = 1
          end
        
          puts " #{count} entities found.\n"
        end
      
        puts "Found #{entities.size} unique '#{category}' entities\n\n"
        
        entities.keys.sort.each do |entity|
          name, domain = split_entity_and_domain(entity)
          output.write(name, entity, domain, category.to_s, 1)
        end
      end
    end
  end
end

if $0 == __FILE__
  lister = ListEntitiesByCategory.new
  lister.run
end
