require 'WikiMiner/db'
require 'tuple_stream'
require 'WikiMiner/tasks'
require 'EntityCollector/list_entities_by_category'

class ListLinksToEntities
  def initialize(entities)
    @entities = entities
  end
  
  def run
    num_links = 0
    synonyms = {}
    target = nil
    Links.open :name => :people_name, :mode => :read_all do |src_namespace, src, dst_namespace, dst, caption, type, weight|
      if target != dst
        update_count(target, synonyms.size)
        num_links = 0
        synonyms = {}
        target = dst
      end

      num_links += 1
      synonyms[caption] = synonyms.fetch(caption, 0) + 1
    end    
    update_count(target, synonyms.size)
    
    ranked_entities = @entities.to_a.sort { |x, y| y[1] <=> x[1] }
    (0..99).each { |i| puts "#{ranked_entities[i][0]}: #{ranked_entities[i][1]}\n"}
  end
  
  def update_count(entity, count)
    @entities[entity] = count if @entities.has_key?(entity)
  end
end

if $0 == __FILE__
  entities = {}
  Entities.open :name => :from_categories, :mode => :read_all do |name, full_name, domain, category, is_entity|
    entities[full_name] = 0
  end
  
  llte = ListLinksToEntities.new(entities)
  llte.run
end
