class ParameterizedExecutor
  def initialize(params, &block)
    @block = block
    @params = params
  end
  
  def execute
    keys = @params.keys
    param_index = [0] * keys.length
    
    while true
      params = {}
      keys.each_with_index do |key, index|
        params[key] = @params[key][param_index[index]]
      end
      
      execute_with_params(params)
      
      len = param_index.length
      for i in (0..len)
        return if i == len

        param_index[i] += 1
        break if param_index[i] < @params[keys[i]].length

        param_index[i] = 0
      end
    end
  end
  
  def execute_with_params(params)
    @block.call(params)
  end
  
  def self.execute(params = {}, &block)
    pe = ParameterizedExecutor.new(params, &block)
    pe.execute
  end
end

if $0 == __FILE__
  require 'pp'

  ParameterizedExecutor.execute({:min_length => [2, 5, 10], :min_name => ['test', 'sf'], :dummy => [3, 2, 6]}) do |params|
    pp params
  end
  
  ParameterizedExecutor.execute({}) do |params|
    pp params
  end
end
