require 'ferret'
require 'pp'

Ferret::Index::Index.new(:path => 'e:/wiki/index', :analyzer => Ferret::Analysis::WhiteSpaceAnalyzer.new) do |index|
  index.search_each('mccain', :limit => 200) do |id, score|
    puts "id: #{id} score: #{score}\n"
    puts index[id][:name]
    
    entities = []
    index[id][:synonyms].scan(/SYN (.*) SYN (\d+)/) do |match|
      entities << [match[0], match[1].to_i]
    end
    entities.sort { |x, y| y[1] <=> x[1] }.each do |entity, weight|
      puts "#{entity} --- #{weight}"
    end
    
    puts index[id][:spec]
#    puts index[id][:synonyms]
    puts "\n\n"
  end
end
