require 'sqlite3'
require 'tuple_stream'

class Object
  def try(method, *args)
    send method, *args if respond_to?(method)
  end
end

module Config
  @options = {}

  class << self  
    def [](key)
      @options[key]
    end
  
    def []=(key, value)
      @options[key] = value
    end
  end
end

def open_db
  db = SQLite3::Database.new("#{Config[:root]}db/wiki_db.sqlite3", {})
  db.busy_timeout(15000)
  db.results_as_hash = true
  return db
end

Config[:root] = 'e:/wiki/'
Config[:db] = open_db
Config[:lock] = "#{Config[:root]}lock"
Config[:log] = "#{Config[:root]}log.txt"
Config[:xml_dump] = 'e:/Downloads/enwiki-latest-pages-articles.xml/enwiki-latest-pages-articles.xml'
Config[:language] = 'en'

#TupleStream[:options]
