class Names
  def initialize(reset = false)
    init(reset)
  end
  
  def reset
    init(true)
  end

  def finish
    @stmt.close
  end

  def db
    @db ||= Config[:db]
  end

  def [](name); prepare; @names[name] end

  def push(name)
    prepare
    name.strip!
    id = @names[name] = @names.length
    @stmt.execute :id => id, :name => name    
    return id    
  end
  alias << push

  def init(reset)
    db.execute('DROP TABLE Names') if reset
    db.execute('CREATE TABLE IF NOT EXISTS Names(ID Int, Name VARCHAR(127), PRIMARY KEY(ID))')

    @stmt.close if @stmt    
    @stmt = db.prepare('INSERT INTO NAMES(ID, Name) VALUES(:id, :name)')
  end
  
  def prepare
    if @names.nil?
      @names = {}
      db.execute('SELECT ID, Name FROM Names') { |row| @names[row[:Name]] = row[:ID] }
    end
  end
end
