require 'EntityCollector/entities'

class WriteTemplates
  def <<(item)
    if item[:namespace] == 'Template'
      @stmt ||= Config[:db].prepare('INSERT INTO Templates(Name, Template) VALUES (:name, :template)')
      @stmt.execute :name => item[:title], :template => item[:text]
    end
  end
  
  def finish
    @stmt.close if @stmt
  end
end

class WriteTopics
  def <<(item)
    @stmt ||= Config[:db].prepare('INSERT INTO Topics(Namespace, Name, Flags, Has_Content) VALUES(:namespace, :name, :flags, :has_content)')
    @stmt.execute :namespace => item[:namespace_key], :name => item[:title], :flags => 0, :has_content => true
  end
  
  def finish; @stmt.clas if @stmt end
end

class Links < TupleStream
  define_field :src_namespace, :integer
  define_field :src, :string
  define_field :dst_namespace, :integer
  define_field :dst, :string
  define_field :caption, :string
  define_field :type, :string
  define_field :weight, :integer
  
  define_comparator :src, [:src_namespace, :src]
  define_comparator :dst, [:dst_namespace, :dst]
end

class WriteLinksAndRedirects
  def initialize
    #    @cache = {}
    #    @id_stmt = Config[:db].prepare('SELECT id FROM topics WHERE namespace = :namespace AND name = :name')
    #    @insert_link_stmt = Config[:db].prepare('INSERT INTO Links(Src, Dst, Caption, Count) VALUES(:src, :dst, :caption, :count)')
    #    @insert_redirect_stmt = Config[:db].prepare('INSERT INTO Redirects(Src, Dst) VALUES(:src, :dst)')
    #    
    #    read_topics
    
    #    Config[:db].execute('SELECT Id, Namespace, Name FROM Topics') do |r|
    #      namespace = r['namespace'].to_i
    #      key = r['name']
    #      key = "#{Wikipedia::namespace_to_name(namespace)}:#{key}" unless namespace == 0
    #      @cache[key] = r['id'].to_i
    #    end
    
    #    RubyProf.start
    @stream = Links.open :mode => :write
  end
  #
  #  def read_topics
  #    topics_cache = "#{Config[:root]}topicscache.dat"
  #    if File.exists?(topics_cache)
  #      File.open(topics_cache, 'rb') { |f| @cache = Marshal.load(f) }
  #    else
  #      @cache = {}
  #      Config[:db].execute('SELECT Id, Namespace, Name FROM Topics') do |r|
  #        namespace = r['namespace'].to_i
  #        key = r['name']
  #        key = Wikipedia::namespace_to_name(namespace) + ':' + key unless namespace == 0
  #        @cache[key] = r['id'].to_i
  #      end
  #      File.open(topics_cache, 'wb') { |f| Marshal.dump(@cache, f) }
  #    end
  #  end
  #
  #  def cache_key(namespace, name)
  #    if namespace.length > 0
  #      "#{namespace}:#{name}"
  #    else
  #      name
  #    end
  #    #    key = name
  #    #    key = Wikipedia::namespace_to_name(namespace) + ':' + key unless namespace == 0
  #    #    return key
  #  end

  #  def get_id(namespace, name)
  #    id = @cache[cache_key(namespace, name)]
  #    return id if id
  #    
  #    #    puts "#{namespace}>>#{name}\n"
  #    
  #    return nil
  #    key = "#{namespace}:#{name}"
  #    return @cache[key] if @cache[key]
  #
  #    @cache.clear if @cache.length > 50000
  #
  #    namespace_id = Wikipedia::namespace_to_id(namespace)
  #
  #    rows = @id_stmt.execute! :namespace => namespace_id, :name => name
  #    if rows.length > 0
  #      @cache[key] = rows.first['id']
  #    else
  #      #      puts "!!!#{namespace}||#{name}||"
  #      #      @insert_id_stmt ||= Config[:db].prepare('INSERT INTO topics(Namespace, Name, Flags, Has_Content) VALUES(:namespace, :name, :flags, :has_content)')
  #      #      @insert_id_stmt.execute :namespace => 0, :name => name, :flags => 0, :has_content => false
  #      #      get_id(name)      
  #      nil
  #    end
  #  end
  #
  def collect_links(text)
    links = Hash.new(0)

    text.scan(/\[\[([^\]\|]+)(?:\|([^\]]*))?\]\]/) do |m|
      dst_name = m[0].strip
      
      # Since [[Category:Some category]] is used to denote that the article belongs to the category, to link to a category, the link is prefixed by a colon
      unless dst_name =~ /^Category:/ or dst_name.length == 0
        dst_name.gsub!(/^:/, '')
        
        caption = (m[1] || '').strip
        links[[dst_name, caption]] += 1
      end
    end

    return links
  end
  
  #  def get_source(item)
  #    get_id(item[:namespace], item[:title])
  #  end
  #  
  #  def get_destination(dst)
  #    link = Wikipedia::parse_link(dst)
  #    #    puts "#{dst}\n"
  #    #    pp link
  #    return nil unless link[:language] == Config[:language] and link[:namespace] == ''
  #    #    puts "added\n"
  #    get_id(link[:namespace], link[:name]) unless link[:anchor] # ignore links with an anchor
  #  end

  def <<(item)
    return unless item[:namespace] == ''
    
    #    @counter ||= 0
    #    @counter += 1
    #    if @counter == 1000
    #      result = RubyProf.stop
    #      printer = RubyProf::FlatPrinter.new(result)
    #      printer.print(STDOUT, 0)
    #    end
    
    text = item[:text]
    
    if text =~ /^\#REDIRECT.*?\[\[([^\]\|]+)(?:|([^\]]*))\]\]/i
      dst = Wikipedia::parse_link($1)
      @stream.write(item[:namespace_key], item[:title], dst[:namespace_key], dst[:name], '', 'redirect', 1)
      
      #      src, dst = get_source(item), get_destination($1)
      #      @insert_redirect_stmt.execute :src => src, :dst => dst if dst

      #      puts "#{item[:title]}>>#{text}" if $2
    else
      links = collect_links(item[:text])

      if !links.empty?
        #        src = get_source(item)
        links.each_pair do |key, value|
          dst, caption = key
          dst = Wikipedia::parse_link(dst)
          @stream.write(item[:namespace_key], item[:title], dst[:namespace_key], dst[:name], caption, 'link', value) if dst[:language] == Config[:language] and dst[:namespace] == ''
          #          dst_id = get_destination(dst)
          #          @insert_link_stmt.execute :src => src, :dst => dst_id, :caption => caption, :count => value if dst_id
        end
      end
    end
  end

  def finish
    @stream.close
    #    @insert_link_stmt.close if @insert_link_stmt 
    #    @insert_redirect_stmt.close if @insert_redirect_stmt
    #    @id_stmt.close if @id_stmt
    #    @insert_id_stmt.close if @insert_id_stmt
  end
end

class Categories < TupleStream
  define_field :parent, :string
  define_field :child_namespace, :integer
  define_field :child, :string
  define_field :caption, :string
  
  define_comparator :by_parent, [:parent]
end

class WriteCategories
  def initialize
    @stream = Categories.open :mode => :write
    #    @insert_category_stmt = Config[:db].prepare('INSERT INTO Categories(Id, Name) VALUES(:id, :name)')
    #    
    #    @category_id = {}
  end
  
  def name_to_id(name)
    id = @category_id[name]
    
    unless id
      id = @category_id.length
      @insert_category_stmt.execute :id => id, :name => name
    end
    
    return id
  end
  
  def <<(item)
    Wikipedia::collect_categories(item[:text]).each_pair do |key, value|
      @stream.write(key, item[:namespace_key], item[:title], (value || '').strip)
      #      @stmt.execute :parent => name_to_id(key), :child => item[], :caption => value
    end
  end
  
  def init
    
  end
  
  def finish
    @stream.close
    timer :sort_categories_by_parent do
      Categories.sort :order => :by_parent
      #      Categories.sort('categories', 'categories_by_parent', :by_parent)
    end
  end
end

#class Entities < TupleStream
#  define_field :title, :string
#  define_field :name, :string
#  define_field :domain, :string
#  define_field :class, :integer
#end

class WriteEntities
  def initialize
    @stream = Entities.open :mode => :write, :name => :classified_entities
  end
  
  def finish
    @stream.close
  end
  
  def is_capitalized(term)
    term.length > 0 and /[A-Z]/ =~ term.first
  end
  
  def count_capitalized_tokens(tokens)
    count = 0
    tokens.each { |x| count += 1 if is_capitalized(x) }
    return count
  end
  
  def count_double_capitalized_tokens(tokens)
    count = 0
    tokens.each { |x| count += 1 if x =~ /[A-Z].*?[A-Z]/ }
    return count
  end
  
  def capitalized_in_text?(name, text)
    exact = 0
    nonexact = 0
    
    text = text.gsub(/\[\[[^\]]*\]\]|\{[^\{\}]*\}/, '')
    
    return 0 if name =~ /\+|\*|\?|\(|\)|\[|\]/ 
    
    text.scan(/(?:^|[^\w])(#{name})(?:$|[^\w])/i) do |match|
      if name == $1
        exact += 1
      else
        nonexact += 1
      end
    end
    
    return exact >= (exact + nonexact) * 0.75
  end
  
  def has_capitalized_letter(term)
    term =~ /[A-Z]/
  end
  
  def classifier(name, text)
    tokens = name.split(/ /)
    
    if tokens.length >= 2
      cl = ct = ucl = uct = 0
      
      tokens.each do |token|
        l = token.length
        if has_capitalized_letter(token)
          cl += l
          ct += 1
        else
          ucl += l
          uct += 1
        end
      end
    end
  end
  
  def classify_name(name, text)
    tokens = name.split(/ |-/)

    return 1 if tokens.length > 0 and count_capitalized_tokens(tokens) >= 2
    return 2 if count_double_capitalized_tokens(tokens) >= 1
    return 3 if tokens.length == 1 and capitalized_in_text?(name, text)
    return 0
  end
  
  def <<(item)
    return nil unless item[:namespace] == ''
    return nil if item[:text] =~ /\{\{R from CamelCase\}\}/
    return nil if item[:text] =~ /\#REDIRECT/
    return nil if item[:title] =~ /\//

    begin    
      if /^([^\(\)]+)(?:\(([^\)]+)\))?$/ =~ item[:title]
        name, domain = $1, $2
        name.strip! if name
        domain.strip! if domain
      
        type = classify_name(name, item[:text])
        #        if type > 0
        @stream.write(name, item[:title], domain || '', '', type > 0 ? 1 : 0)
        #        end
        #      puts "#{name}|||#{domain}|||#{type}" if domain
      end
    rescue Exception => e
      puts "Failed to classify potential entity due to: #{e}"
      puts "Title: #{item[:title]}"
    end
  end
end

class Titles < TupleStream
  define_field :title, :string
end

class WriteTitles
  def initialize 
    @titles = []
  end
  
  def <<(item)
    @titles << item[:title] if item[:namespace] == ''
  end
  
  def finish
    Titles.open :mode => :write do |stream|
      @titles.each { |title| stream.write(title) }
    end
  end
end

class NullSource
  def initialize; end
  def run; end
  def finish; end
end

class WriteShuffledTitles
  def initialize
  end
  
  def <<(item)
    @titles << item[:title]
  end
  
  def read_titles
    titles = []
    Titles.open do |stream|
      until (item = stream.read).nil?
        titles << item[0]
      end
    end
    return titles
  end
  
  def finish
    srand(9823523)
    titles = read_titles.sort_by { rand }
    
    (0..99).each { |i| puts titles[i] }
    
    Titles.open :name => :shuffled, :mode => :write do |stream|
      titles.each { |title| stream.write(title) }
    end
  end
end

class WriteCategoryPages
  def initialize
    @stmt = Config[:db].prepare('INSERT INTO category_pages(title, category, namespace) VALUES (:title, :category, :namespace)')
  end
  
  def finish
    @stmt.close if @stmt
  end
  
  def <<(item)
    Wikipedia::collect_categories(item[:text]).each_key do |category|
      @stmt.execute :title => item[:title], :category => category, :namespace => item[:namespace]
    end
  end
end
