module Wikipedia
  @namespaces_by_name = {'Media' => -2, 
    'Special' => -1, 
    '' => 0, 
    'Talk' => 1, 
    'User' => 2, 
    'User talk' => 3, 
    'Wikipedia' => 4, 
    'Wikipedia talk' => 5,
    'Image' => 6,
    'Image talk' => 7,
    'MediaWiki' => 8,
    'MediaWiki talk' => 9,
    'Template' => 10,
    'Template talk' => 11,
    'Help' => 12,
    'Help talk' => 13,
    'Category' => 14,
    'Category talk' => 15,
    'Portal' => 100,
    'Portal talk' => 101
  }
  @namespaces_by_id = @namespaces_by_name.invert
  
  @language_namespaces = {
    'aa' => 1,'ab' => 1,'af' => 1,'ak' => 1,'aln' => 1,'als' => 1,'am' => 1,'an' => 1,'ang' => 1,
    'ar' => 1,'arc' => 1,'arn' => 1,'as' => 1,'ast' => 1,'av' => 1,'avk' => 1,'ay' => 1,'az' => 1,
    'ba' => 1,'bar' => 1,'bat-smg' => 1,'bcl' => 1,'be' => 1,'be-tarask' => 1,'be-x-old' => 1,
    'bg' => 1,'bh' => 1,'bi' => 1,'bm' => 1,'bn' => 1,'bo' => 1,'bpy' => 1,'br' => 1,'bs' => 1,
    'bto' => 1,'bug' => 1,'bxr' => 1,'ca' => 1,'cbk-zam' => 1,'cdo' => 1,'ce' => 1,'ceb' => 1,
    'ch' => 1,'cho' => 1,'chr' => 1,'chy' => 1,'co' => 1,'cr' => 1,'crh' => 1,'crh-latn' => 1,
    'crh-cyrl' => 1,'cs' => 1,'csb' => 1,'cu' => 1,'cv' => 1,'cy' => 1,'da' => 1,'de' => 1,'de-formal' => 1,
    'diq' => 1,'dk' => 1,'dsb' => 1,'dum' => 1,'dv' => 1,'dz' => 1,'ee' => 1,'el' => 1,'eml' => 1,'en' => 1,
    'eo' => 1,'es' => 1,'et' => 1,'eu' => 1,'ext' => 1,'fa' => 1,'ff' => 1,'fi' => 1,'fiu-vro' => 1,'fj' => 1,
    'fo' => 1,'fr' => 1,'frc' => 1,'frp' => 1,'fur' => 1,'fy' => 1,'ga' => 1,'gag' => 1,'gan' => 1,'gd' => 1,
    'gl' => 1,'glk' => 1,'gn' => 1,'got' => 1,'grc' => 1,'gsw' => 1,'gu' => 1,'gv' => 1,'ha' => 1,'hak' => 1,
    'haw' => 1,'he' => 1,'hi' => 1,'hil' => 1,'ho' => 1,'hr' => 1,'hsb' => 1,'ht' => 1,'hu' => 1,'hy' => 1,'hz' => 1,
    'ia' => 1,'id' => 1,'ie' => 1,'ig' => 1,'ii' => 1,'ik' => 1,'ike-cans' => 1,'ike-latn' => 1,'ilo' => 1,'inh' => 1,
    'io' => 1,'is' => 1,'it' => 1,'iu' => 1,'ja' => 1,'jbo' => 1,'jut' => 1,'jv' => 1,'ka' => 1,'kaa' => 1,'kab' => 1,
    'kg' => 1,'ki' => 1,'kj' => 1,'kk' => 1,'kk-arab' => 1,'kk-cyrl' => 1,'kk-latn' => 1,'kk-cn' => 1,'kk-kz' => 1,
    'kk-tr' => 1,'kl' => 1,'km' => 1,'kn' => 1,'ko' => 1,'kr' => 1,'kri' => 1,'krj' => 1,'ks' => 1,'ksh' => 1,'ku' => 1,
    'ku-latn' => 1,'ku-arab' => 1,'kv' => 1,'kw' => 1,'ky' => 1,'la' => 1,'lad' => 1,'lb' => 1,'lbe' => 1,'lez' => 1,'lfn' => 1,
    'lg' => 1,'li' => 1,'lij' => 1,'lld' => 1,'lmo' => 1,'ln' => 1,'lo' => 1,'loz' => 1,'lt' => 1,'lv' => 1,'lzz' => 1,'mai' => 1,
    'map-bms' => 1,'mdf' => 1,'mg' => 1,'mh' => 1,'mi' => 1,'mk' => 1,'ml' => 1,'mn' => 1,'mo' => 1,'mr' => 1,'ms' => 1,'mt' => 1,
    'mus' => 1,'mwl' => 1,'my' => 1,'myv' => 1,'mzn' => 1,'na' => 1,'nah' => 1,'nan' => 1,'nap' => 1,'nb' => 1,'nds' => 1,
    'nds-nl' => 1,'ne' => 1,'new' => 1,'ng' => 1,'niu' => 1,'nl' => 1,'nn' => 1,'no' => 1,'non' => 1,'nov' => 1,'nrm' => 1,
    'nso' => 1,'nv' => 1,'ny' => 1,'oc' => 1,'om' => 1,'or' => 1,'os' => 1,'pa' => 1,'pag' => 1,'pam' => 1,'pap' => 1,
    'pdc' => 1,'pdt' => 1,'pfl' => 1,'pi' => 1,'pih' => 1,'pl' => 1,'plm' => 1,'pms' => 1,'pnt' => 1,'ps' => 1,'pt' => 1,
    'pt-br' => 1,'qu' => 1,'rm' => 1,'rmy' => 1,'rn' => 1,'ro' => 1,'roa-rup' => 1,'roa-tara' => 1,'ru' => 1,'ruq' => 1,
    'ruq-cyrl' => 1,'ruq-grek' => 1,'ruq-latn' => 1,'rw' => 1,'sa' => 1,'sah' => 1,'sc' => 1,'scn' => 1,'sco' => 1,
    'sd' => 1,'sdc' => 1,'se' => 1,'sei' => 1,'sg' => 1,'sh' => 1,'shi' => 1,'si' => 1,'simple' => 1,'sk' => 1,'sl' => 1,
    'sm' => 1,'sma' => 1,'sn' => 1,'so' => 1,'sq' => 1,'sr' => 1,'sr-ec' => 1,'sr-jc' => 1,'sr-el' => 1,'sr-jl' => 1,
    'srn' => 1,'ss' => 1,'st' => 1,'stq' => 1,'su' => 1,'sv' => 1,'sw' => 1,'ta' => 1,'te' => 1,'tet' => 1,'tg' => 1,'th' => 1,
    'ti' => 1,'tk' => 1,'tl' => 1,'tn' => 1,'to' => 1,'tokipona' => 1,'tp' => 1,'tpi' => 1,'tr' => 1,'ts' => 1,'tt' => 1,
    'tum' => 1,'tw' => 1,'ty' => 1,'tyv' => 1,'tzm' => 1,'udm' => 1,'ug' => 1,'uk' => 1,'ur' => 1,'uz' => 1,'ve' => 1,'vec' => 1,
    'vi' => 1,'vls' => 1,'vo' => 1,'wa' => 1,'war' => 1,'wo' => 1,'wuu' => 1,'xal' => 1,'xh' => 1,'xmf' => 1,'ydd' => 1,'yi' => 1,
    'yo' => 1,'yue' => 1,'za' => 1,'zea' => 1,'zh' => 1,'zh-classical' => 1,'zh-cn' => 1,'zh-hans' => 1,'zh-hant' => 1,'zh-hk' => 1,
    'zh-min-nan' => 1,'zh-sg' => 1,'zh-tw' => 1,'zh-yue' => 1,'zu' => 1  
  }
  
  attr_accessor :namespaces_by_name, :language_namespaces
  
  def fix_title_case(title)
    title[0] = title[0..0].upcase if title.length > 0
    title    
  end
  
  def parse_link(title)
    t, anchor = title.split('#', 2)

    #    t.gsub!('_', ' ')
    t.tr!('_', ' ') if /_/ =~ t
    t.strip!
    
    if t =~ /^([\w\s]+):(.+)/ and ((is_namespace = @namespaces_by_name.has_key?($1)) or (is_language = @language_namespaces.has_key?($1.downcase)))
      language = $1.downcase if is_language
      name = $2.strip
      namespace = $1 if is_namespace
    else
      name = t
    end
    
    language = Config[:language] unless language
    namespace = '' unless namespace
    {:anchor => anchor, :language => language, :name => fix_title_case(name), :namespace => namespace, :namespace_key => @namespaces_by_name[namespace]}
  end
  
  def namespace_to_id(namespace)
    @namespaces_by_name[namespace] || @namespaces_by_name['']
  end
  
  def namespace_to_name(id)
    @namespaces_by_id[id] || @namespaces_by_id[0]
  end
  
  def collect_categories(text)
    categories = {}
    text.scan(%r{\[\[Category:([^|\]]+)(?:|[^\]]*)?\]\]}) { |name| categories[$1.strip] = $2 }
    return categories
  end
  
  module_function :fix_title_case, :parse_link, :namespace_to_id, :namespace_to_name, :collect_categories
end
