require 'wiki_page_reader'

class WikiTitles
  def initialize
    @title_lookup = Hash.new()
    @titles = Array.new
  end
  
  def push(title)
    index = @titles.length
    @titles.push([title, index])
    #    @title_lookup[title] = index
  end
  
  def load(input)
    #    while !input.eof?
    #      title = Marshal.load(input)
    #      push(title)
    #    end 
    index = 0
    while !input.eof?
      line = input.gets.strip
      @titles.push([line, index])
      index += 1
    end
    
    @titles.sort! { |x, y| x[0] <=> y[0] }
  end
  
  def store(output)
    #    @titles.each { |title| Marshal.dump([title], output) }
    @titles.each{ |title| output.write("#{title[0]}\n#{title[1]}\n")}
  end
end

def extract_titles
  pageTitles = WikiTitles.new
  
  FileStreams.open('e:/wiki') do |fs|
    reader = WikiPageReader.new('e:/wiki/all_pages.dat')
    reader.each { |p| pageTitles.push(p[:title]) }
    
    pageTitles.store(fs.open('titles.dat', 'wb'))
  end
end

def load_titles
  FileStreams.open('e:/wiki') do |fs|
    pageTitles = WikiTitles.new
    pageTitles.load(fs.open('titles.dat', 'rb'))
  end
end

def transform_titles
  FileStreams.open('e:/wiki') do |fs|
    pageTitles = WikiTitles.new
    pageTitles.load(fs.open('titles.dat', 'rb'))
    pageTitles.store(fs.open('titles2.dat', 'w'))
  end
end

#extract_titles
load_titles
transform_titles
