require 'rexml/document'
require 'rexml/streamlistener'
require 'pp'

require 'xml/libxml_so'

include REXML

class WikiXmlParser
  include StreamListener
  include XML::SaxParser::Callbacks
  
  attr_reader :namespaces_by_key, :namespaces_by_name
  
  def initialize(input)
    @namespaces_by_key = {}
    @namespaces_by_name = {}
    @stack = []
    @input = input
    
#    Wikipedia::namespaces_by_name = @namespaces_by_name
  end
  
  def run(&block)
    @block = block
    parser = XML::SaxParser.new
    parser.callbacks = self
    parser.filename = @input
    parser.parse
  end
  
  def on_start_element (name, attr)
    @stack.push(name.to_sym)
    
    case @stack
    when [:mediawiki, :page]
      @title = nil
      @text = nil
    when [:mediawiki, :page, :title], 
        [:mediawiki, :page, :revision, :text]
      @text_buffer = Array.new
#    when [:mediawiki, :siteinfo, :namespaces, :namespace]
#      @ns_key = attr['key'].to_i
#      @text_buffer = Array.new
    end
  end
  
  def on_end_element(name)
    case @stack
    when [:mediawiki, :page]
      link = Wikipedia::parse_link(@title)
      @block.call({:title => link[:name], :text => @text, :namespace => link[:namespace], :namespace_key => Wikipedia::namespace_to_id(link[:namespace])})
    when [:mediawiki, :page, :title]
      @title = @text_buffer.join
    when [:mediawiki, :page, :revision, :text]
      @text = @text_buffer.join
#    when [:mediawiki, :siteinfo, :namespaces, :namespace]
#      ns_name = @text_buffer.join.strip
#      @namespaces_by_key[@ns_key] = ns_name
#      @namespaces_by_name[ns_name] = @ns_key
#      @ns_key = nil
    end
    
    @stack.pop if @stack.last == name.to_sym
    @text_buffer = nil
  end
  
  def on_characters(text)
    @text_buffer.push(text) if @text_buffer
  end
end

if __FILE__ == $0
  #  puts "start\n"
  #  if 'E.L.E. (Extinction Level Event): The Final World Front' =~ /^([\w\s]+)+:(.+)/ and @namespaces_by_name.has_key?($1)
  #      
  #  end
  #  puts "done\n"


  wxp = WikiXmlParser.new('e:/Downloads/enwiki-latest-pages-articles.xml/enwiki-latest-pages-articles.xml')
  wxp.run do |p|
    #  puts "#{p[:namespace]}|||#{p[:namespace_key]}|||#{p[:title]}" if p[:namespace]
    #  pp wxp.namespaces
    #  raise Exception.new
  end
end

#parser.create do |p|
#  p.for_each :mediawiki, :page do |a|
#    a.capture :title
#    a.capture :
#  end
#end
